\name{aRTtheme-class}
\docType{class}
\alias{aRTtheme-class}
\alias{aRTtheme}
\alias{getAttributes,aRTtheme-method}
\alias{getBox,aRTtheme-method}
\alias{getData,aRTtheme-method}
\alias{getGeometry,aRTtheme-method}
\alias{initialize,aRTtheme-method}
\alias{saveTheme,aRTtheme-method}
\alias{selectTables,aRTtheme-method}
\alias{setAR,aRTtheme-method}
\alias{setSR,aRTtheme-method}
\alias{setTR,aRTtheme-method}

\title{Class "aRTtheme"}
\description{Class that enables a database query with spatial, temporal and attributes
restrictions. All queries are done using restrictions stored in the object.}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("aRTtheme", aRTlayer, themename)}.
}

\section{Slots}{
\describe{
    \item{\code{pointer}:}{An external pointer to a TerraLib object. DO NOT change it!}
  }
}

\section{Extends}{
Class \code{aRTcomponent}, directly.
}
\section{Methods}{
  \describe{
    \item{getAttributes:}{ Do a query and return all.}
    \item{getBox:}{ Returns the bounding box.}
    \item{getData:}{ Returns all attributes and geometry of a layer.}
    \item{getGeometry:}{Returns all the geometry associated with the object.}
    \item{initialize:}{ Initializer of aRTtheme class.}
    \item{setAR:}{Sets the attribute restrictions of the query. (not implemented yet)}
    \item{setSR:}{Sets the spatial restrictions of the query. (not implemented yet)}
    \item{setTR:}{Sets the temporal restrictions of the query. (not implemented yet)}
  }
}

\references{\url{http://www.est.ufpr.br/aRT}}

\author{Marcos Aurelio Carrero and Pedro Ribeiro de Andrade Neto}
\keyword{database}
\seealso{
 See \code{aRTtheme-METHOD} for a method of this class or \code{CLASSNAME-class} for links to other classes.
}
